Index: pjproject/main/pjlib/include/pj++/proactor.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/proactor.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/proactor.hpp	(revision 36)
@@ -1,7 +1,6 @@
 /* $Id$
- *
  */
-#ifndef __PJPP_EVENT_HANDLER_H__
-#define __PJPP_EVENT_HANDLER_H__
+#ifndef __PJPP_PROACTOR_H__
+#define __PJPP_PROACTOR_H__
 
 #include <pj/ioqueue.h>
@@ -9,80 +8,474 @@
 #include <pj++/sock.hpp>
 #include <pj++/timer.hpp>
-
-class PJ_Proactor;
-
-
-class PJ_Event_Handler
+#include <pj/errno.h>
+
+class Pj_Proactor;
+class Pj_Event_Handler;
+
+
+//////////////////////////////////////////////////////////////////////////////
+// Asynchronous operation key.
+//
+// Applications may inheric this class to put their application
+// specific data.
+//
+class Pj_Async_Op : public pj_ioqueue_op_key_t
 {
-    friend class PJ_Proactor;
 public:
-    PJ_Event_Handler();
-    virtual ~PJ_Event_Handler();
-
-    virtual pj_oshandle_t get_handle() = 0;
-
-    bool read(void *buf, pj_size_t len);
-    bool recvfrom(void *buf, pj_size_t len, PJ_INET_Addr *addr);
-    bool write(const void *data, pj_size_t len);
-    bool sendto(const void *data, pj_size_t len, const PJ_INET_Addr &addr);
+    //
+    // Constructor.
+    //
+    explicit Pj_Async_Op(Pj_Event_Handler *handler)
+        : handler_(handler)
+    {
+        pj_memset(this, 0, sizeof(pj_ioqueue_op_key_t));
+    }
+
+    //
+    // Check whether operation is still pending for this key.
+    //
+    bool is_pending();
+
+    //
+    // Cancel the operation.
+    //
+    bool cancel(pj_ssize_t bytes_status=-PJ_ECANCELLED);
+
+protected:
+    Pj_Event_Handler *handler_;
+};
+
+
+//////////////////////////////////////////////////////////////////////////////
+// Event handler.
+//
+// Applications should inherit this class to receive various event
+// notifications.
+//
+// Applications should implement get_socket_handle().
+//
+class Pj_Event_Handler : public Pj_Object
+{
+    friend class Pj_Proactor;
+public:
+    //
+    // Default constructor.
+    //
+    Pj_Event_Handler()
+        : key_(NULL)
+    {
+        pj_memset(&timer_, 0, sizeof(timer_));
+        timer_.user_data = this;
+        timer_.cb = &timer_callback;
+    }
+    
+    //
+    // Destroy.
+    //
+    virtual ~Pj_Event_Handler()
+    {
+        unregister();
+    }
+
+    //
+    // Unregister this handler from the ioqueue.
+    //
+    void unregister()
+    {
+        if (key_) {
+            pj_ioqueue_unregister(key_);
+            key_ = NULL;
+        }
+    }
+
+    //
+    // Get socket handle associated with this.
+    //
+    virtual pj_sock_t get_socket_handle()
+    {
+        return PJ_INVALID_SOCKET;
+    }
+
+    //
+    // Receive data.
+    //
+    pj_status_t recv( Pj_Async_Op *op_key, 
+                      void *buf, pj_ssize_t *len, 
+                      unsigned flags)
+    {
+        return pj_ioqueue_recv( key_, op_key,
+                                buf, len, flags);
+    }
+
+    //
+    // Recvfrom()
+    //
+    pj_status_t recvfrom( Pj_Async_Op *op_key, 
+                          void *buf, pj_ssize_t *len, unsigned flags,
+                          Pj_Inet_Addr *addr)
+    {
+        addr->addrlen_ = sizeof(Pj_Inet_Addr);
+        return pj_ioqueue_recvfrom( key_, op_key, buf, len, flags,
+                                    addr, &addr->addrlen_ );
+    }
+
+    //
+    // send()
+    //
+    pj_status_t send( Pj_Async_Op *op_key, 
+                      const void *data, pj_ssize_t *len, 
+                      unsigned flags)
+    {
+        return pj_ioqueue_send( key_, op_key, data, len, flags);
+    }
+
+    //
+    // sendto()
+    //
+    pj_status_t sendto( Pj_Async_Op *op_key,
+                        const void *data, pj_ssize_t *len, unsigned flags,
+                        const Pj_Inet_Addr &addr)
+    {
+        return pj_ioqueue_sendto(key_, op_key, data, len, flags,
+                                 &addr, sizeof(addr));
+    }
+
 #if PJ_HAS_TCP
-    bool connect(const PJ_INET_Addr &addr);
-    bool accept(PJ_Socket *sock, PJ_INET_Addr *local=NULL, PJ_INET_Addr *remote=NULL);
+    //
+    // connect()
+    //
+    pj_status_t connect(const Pj_Inet_Addr &addr)
+    {
+        return pj_ioqueue_connect(key_, &addr, sizeof(addr));
+    }
+
+    //
+    // accept.
+    //
+    pj_status_t accept( Pj_Async_Op *op_key,
+                        Pj_Socket *sock, 
+                        Pj_Inet_Addr *local = NULL, 
+                        Pj_Inet_Addr *remote = NULL)
+    {
+        int *addrlen = local ? &local->addrlen_ : NULL;
+        return pj_ioqueue_accept( key_, op_key, &sock->sock_,
+                                  local, remote, addrlen );
+    }
+
 #endif
 
 protected:
-    //
+    //////////////////
     // Overridables
-    //
-    virtual void on_timeout(int data) {}
-    virtual void on_read_complete(pj_ssize_t bytes_read) {}
-    virtual void on_write_complete(pj_ssize_t bytes_sent) {}
+    //////////////////
+
+    //
+    // Timeout callback.
+    //
+    virtual void on_timeout(int data) 
+    {
+    }
+
+    //
+    // On read complete callback.
+    //
+    virtual void on_read_complete( Pj_Async_Op *op_key,
+                                   pj_ssize_t bytes_read) 
+    {
+    }
+
+    //
+    // On write complete callback.
+    //
+    virtual void on_write_complete( Pj_Async_Op *op_key, 
+                                    pj_ssize_t bytes_sent) 
+    {
+    }
+
 #if PJ_HAS_TCP
-    virtual void on_connect_complete(int status) {}
-    virtual void on_accept_complete(int status) {}
+    //
+    // On connect complete callback.
+    //
+    virtual void on_connect_complete(pj_status_t status) 
+    {
+    }
+
+    //
+    // On new connection callback.
+    //
+    virtual void on_accept_complete( Pj_Async_Op *op_key,
+                                     pj_sock_t new_sock,
+                                     pj_status_t status) 
+    {
+    }
+
 #endif
 
+
 private:
-    PJ_Proactor	     *proactor_;
     pj_ioqueue_key_t *key_;
     pj_timer_entry    timer_;
-    int		      tmp_recvfrom_addr_len;
-
-public:
-    // Internal IO Queue/timer callback.
-    static void timer_callback( pj_timer_heap_t *timer_heap, struct pj_timer_entry *entry);
-    static void read_complete_cb(pj_ioqueue_key_t *key, pj_ssize_t bytes_read);
-    static void write_complete_cb(pj_ioqueue_key_t *key, pj_ssize_t bytes_sent);
-    static void accept_complete_cb(pj_ioqueue_key_t *key, int status);
-    static void connect_complete_cb(pj_ioqueue_key_t *key, int status);
+
+    friend class Pj_Proactor;
+    friend class Pj_Async_Op;
+
+    //
+    // Static timer callback.
+    //
+    static void timer_callback( pj_timer_heap_t *timer_heap, 
+                                struct pj_timer_entry *entry)
+    {
+        Pj_Event_Handler *handler = 
+            (Pj_Event_Handler*) entry->user_data;
+
+        handler->on_timeout(entry->id);
+    }
 };
 
-class PJ_Proactor
+inline bool Pj_Async_Op::is_pending()
+{
+    return pj_ioqueue_is_pending(handler_->key_, this) != 0;
+}
+
+inline bool Pj_Async_Op::cancel(pj_ssize_t bytes_status)
+{
+    return pj_ioqueue_post_completion(handler_->key_, this, 
+                                      bytes_status) == PJ_SUCCESS;
+}
+
+//////////////////////////////////////////////////////////////////////////////
+// Proactor
+//
+class Pj_Proactor : public Pj_Object
 {
 public:
-    static PJ_Proactor *create(PJ_Pool *pool, pj_size_t max_fd, 
-			       pj_size_t timer_entry_count, unsigned timer_flags=0);
-
-    void destroy();
-
-    bool register_handler(PJ_Pool *pool, PJ_Event_Handler *handler);
-    void unregister_handler(PJ_Event_Handler *handler);
-
-    static bool schedule_timer( pj_timer_heap_t *timer, PJ_Event_Handler *handler,
-				const PJ_Time_Val &delay, int id=-1);
-    bool schedule_timer(PJ_Event_Handler *handler, const PJ_Time_Val &delay, int id=-1);
-    bool cancel_timer(PJ_Event_Handler *handler);
-
-    bool handle_events(PJ_Time_Val *timeout);
-
-    pj_ioqueue_t *get_io_queue();
-    pj_timer_heap_t *get_timer_heap();
+    //
+    // Default constructor, initializes to NULL.
+    //
+    Pj_Proactor()
+        : ioq_(NULL), th_(NULL)
+    {
+        cb_.on_read_complete    = &read_complete_cb;
+        cb_.on_write_complete   = &write_complete_cb;
+        cb_.on_accept_complete  = &accept_complete_cb;
+        cb_.on_connect_complete = &connect_complete_cb;
+    }
+
+    //
+    // Construct proactor.
+    //
+    Pj_Proactor( Pj_Pool *pool, pj_size_t max_fd,
+                 pj_size_t max_timer_entries )
+    : ioq_(NULL), th_(NULL)
+    {
+        cb_.on_read_complete    = &read_complete_cb;
+        cb_.on_write_complete   = &write_complete_cb;
+        cb_.on_accept_complete  = &accept_complete_cb;
+        cb_.on_connect_complete = &connect_complete_cb;
+    }
+
+    //
+    // Destructor.
+    //
+    ~Pj_Proactor()
+    {
+        destroy();
+    }
+
+    //
+    // Create proactor.
+    //
+    pj_status_t create( Pj_Pool *pool, pj_size_t max_fd, 
+			pj_size_t timer_entry_count)
+    {
+        pj_status_t status;
+
+        destroy();
+
+        status = pj_ioqueue_create(pool->pool_(), max_fd, &ioq_);
+        if (status != PJ_SUCCESS) 
+            return status;
+        
+        status = pj_timer_heap_create(pool->pool_(), 
+                                      timer_entry_count, &th_);
+        if (status != PJ_SUCCESS) {
+            pj_ioqueue_destroy(ioq_);
+            ioq_ = NULL;
+            return NULL;
+        }
+        
+        status;
+    }
+
+    //
+    // Destroy proactor.
+    //
+    void destroy()
+    {
+        if (ioq_) {
+            pj_ioqueue_destroy(ioq_);
+            ioq_ = NULL;
+        }
+        if (th_) {
+            pj_timer_heap_destroy(th_);
+            th_ = NULL;
+        }
+    }
+
+    //
+    // Register handler.
+    // This will call handler->get_socket_handle()
+    //
+    pj_status_t register_socket_handler(Pj_Pool *pool, 
+                                        Pj_Event_Handler *handler)
+    {
+        return   pj_ioqueue_register_sock( pool->pool_(), ioq_,
+                                           handler->get_socket_handle(),
+                                           handler, &cb_, &handler->key_ );
+    }
+
+    //
+    // Unregister handler.
+    //
+    static void unregister_handler(Pj_Event_Handler *handler)
+    {
+        if (handler->key_) {
+            pj_ioqueue_unregister( handler->key_ );
+            handler->key_ = NULL;
+        }
+    }
+
+    //
+    // Scheduler timer.
+    //
+    bool schedule_timer( Pj_Event_Handler *handler, 
+                         const Pj_Time_Val &delay, 
+                         int id=-1)
+    {
+        return schedule_timer(th_, handler, delay, id);
+    }
+
+    //
+    // Cancel timer.
+    //
+    bool cancel_timer(Pj_Event_Handler *handler)
+    {
+        return pj_timer_heap_cancel(th_, &handler->timer_) == 1;
+    }
+
+    //
+    // Handle events.
+    //
+    int handle_events(Pj_Time_Val *max_timeout)
+    {
+        Pj_Time_Val timeout(0, 0);
+        int timer_count;
+
+        timer_count = pj_timer_heap_poll( th_, &timeout );
+
+        if (timeout.get_sec() < 0) 
+            timeout.sec = PJ_MAXINT32;
+
+        /* If caller specifies maximum time to wait, then compare the value 
+         * with the timeout to wait from timer, and use the minimum value.
+         */
+        if (max_timeout && timeout >= *max_timeout) {
+	    timeout = *max_timeout;
+        }
+
+        /* Poll events in ioqueue. */
+        int ioqueue_count;
+
+        ioqueue_count = pj_ioqueue_poll(ioq_, &timeout);
+        if (ioqueue_count < 0)
+	    return ioqueue_count;
+
+        return ioqueue_count + timer_count;
+    }
+
+    //
+    // Get the internal ioqueue object.
+    //
+    pj_ioqueue_t *get_io_queue()
+    {
+        return ioq_;
+    }
+
+    //
+    // Get the internal timer heap object.
+    //
+    pj_timer_heap_t *get_timer_heap()
+    {
+        return th_;
+    }
 
 private:
     pj_ioqueue_t *ioq_;
     pj_timer_heap_t *th_;
-
-    PJ_Proactor() {}
+    pj_ioqueue_callback cb_;
+
+    static bool schedule_timer( pj_timer_heap_t *timer, 
+                                Pj_Event_Handler *handler,
+				const Pj_Time_Val &delay, 
+                                int id=-1)
+    {
+        handler->timer_.id = id;
+        return pj_timer_heap_schedule(timer, &handler->timer_, &delay) == 0;
+    }
+
+
+    //
+    // Static read completion callback.
+    //
+    static void read_complete_cb( pj_ioqueue_key_t *key, 
+                                  pj_ioqueue_op_key_t *op_key, 
+                                  pj_ssize_t bytes_read)
+    {
+        Pj_Event_Handler *handler = 
+	    (Pj_Event_Handler*) pj_ioqueue_get_user_data(key);
+
+        handler->on_read_complete((Pj_Async_Op*)op_key, bytes_read);
+    }
+
+    //
+    // Static write completion callback.
+    //
+    static void write_complete_cb(pj_ioqueue_key_t *key, 
+                                  pj_ioqueue_op_key_t *op_key,
+                                  pj_ssize_t bytes_sent)
+    {
+        Pj_Event_Handler *handler = 
+	    (Pj_Event_Handler*) pj_ioqueue_get_user_data(key);
+
+        handler->on_write_complete((Pj_Async_Op*)op_key, bytes_sent);
+    }
+
+    //
+    // Static accept completion callback.
+    //
+    static void accept_complete_cb(pj_ioqueue_key_t *key, 
+                                   pj_ioqueue_op_key_t *op_key,
+                                   pj_sock_t new_sock,
+                                   pj_status_t status)
+    {
+        Pj_Event_Handler *handler = 
+	    (Pj_Event_Handler*) pj_ioqueue_get_user_data(key);
+
+        handler->on_accept_complete((Pj_Async_Op*)op_key, new_sock, status);
+    }
+
+    //
+    // Static connect completion callback.
+    //
+    static void connect_complete_cb(pj_ioqueue_key_t *key, 
+                                    pj_status_t status)
+    {
+        Pj_Event_Handler *handler = 
+	    (Pj_Event_Handler*) pj_ioqueue_get_user_data(key);
+
+        handler->on_connect_complete(status);
+    }
+
 };
 
-#endif	/* __PJPP_EVENT_HANDLER_H__ */
+#endif	/* __PJPP_PROACTOR_H__ */
Index: pjproject/main/pjlib/include/pj++/scanner.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/scanner.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/scanner.hpp	(revision 36)
@@ -5,11 +5,11 @@
 #define __PJPP_SCANNER_H__
 
-#include <pj/scanner.h>
+#include <pjlib-util/scanner.h>
 #include <pj++/string.hpp>
 
-class PJ_CharSpec
+class Pj_Char_Spec
 {
 public:
-    PJ_CharSpec() { pj_cs_init(cs__); }
+    Pj_Char_Spec() { pj_cs_init(cs__); }
 
     void set(int c) { pj_cs_set(cs__, c); }
@@ -37,8 +37,8 @@
 };
 
-class PJ_Scanner
+class Pj_Scanner
 {
 public:
-    PJ_Scanner() {}
+    Pj_Scanner() {}
 
     enum
@@ -68,28 +68,28 @@
     int peek_char() const
     {
-	return *scanner_.current;
+	return *scanner_.curptr;
     }
 
-    int peek(const PJ_CharSpec *cs, PJ_String *out)
+    int peek(const Pj_Char_Spec *cs, Pj_String *out)
     {
 	return pj_scan_peek(&scanner_,  cs->cs_(), out);
     }
 
-    int peek_n(pj_size_t len, PJ_String *out)
+    int peek_n(pj_size_t len, Pj_String *out)
     {
 	return pj_scan_peek_n(&scanner_, len, out);
     }
 
-    int peek_until(const PJ_CharSpec *cs, PJ_String *out)
+    int peek_until(const Pj_Char_Spec *cs, Pj_String *out)
     {
 	return pj_scan_peek_until(&scanner_, cs->cs_(), out);
     }
 
-    void get(const PJ_CharSpec *cs, PJ_String *out)
+    void get(const Pj_Char_Spec *cs, Pj_String *out)
     {
 	pj_scan_get(&scanner_, cs->cs_(), out);
     }
 
-    void get_n(unsigned N, PJ_String *out)
+    void get_n(unsigned N, Pj_String *out)
     {
 	pj_scan_get_n(&scanner_, N, out);
@@ -101,5 +101,5 @@
     }
 
-    void get_quote(int begin_quote, int end_quote, PJ_String *out)
+    void get_quote(int begin_quote, int end_quote, Pj_String *out)
     {
 	pj_scan_get_quote(&scanner_, begin_quote, end_quote, out);
@@ -111,15 +111,15 @@
     }
 
-    void get_until(const PJ_CharSpec *cs, PJ_String *out)
+    void get_until(const Pj_Char_Spec *cs, Pj_String *out)
     {
 	pj_scan_get_until(&scanner_, cs->cs_(), out);
     }
 
-    void get_until_ch(int until_ch, PJ_String *out)
+    void get_until_ch(int until_ch, Pj_String *out)
     {
 	pj_scan_get_until_ch(&scanner_, until_ch, out);
     }
 
-    void get_until_chr(const char *spec, PJ_String *out)
+    void get_until_chr(const char *spec, Pj_String *out)
     {
 	pj_scan_get_until_chr(&scanner_, spec, out);
Index: pjproject/main/pjlib/include/pj++/sock.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/sock.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/sock.hpp	(revision 36)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJPP_SOCK_H__
@@ -6,66 +5,147 @@
 
 #include <pj/sock.h>
-
-class PJ_Addr
+#include <pj/string.h>
+
+class Pj_Event_Handler;
+
+//
+// Base class for address.
+//
+class Pj_Addr
 {
 };
 
-class PJ_INET_Addr : public pj_sockaddr_in, public PJ_Addr
+//
+// Internet address.
+//
+class Pj_Inet_Addr : public pj_sockaddr_in, public Pj_Addr
 {
 public:
+    //
+    // Get port number.
+    //
     pj_uint16_t get_port_number() const
     {
-	return pj_sockaddr_get_port(this);
-    }
-
+	return pj_sockaddr_in_get_port(this);
+    }
+
+    //
+    // Set port number.
+    //
     void set_port_number(pj_uint16_t port)
     {
 	sin_family = PJ_AF_INET;
-	pj_sockaddr_set_port(this, port);
-    }
-
+	pj_sockaddr_in_set_port(this, port);
+    }
+
+    //
+    // Get IP address.
+    //
     pj_uint32_t get_ip_address() const
     {
-	return pj_sockaddr_get_addr(this);
-    }
-
+	return pj_sockaddr_in_get_addr(this).s_addr;
+    }
+
+    //
+    // Get address string.
+    //
     const char *get_address() const
     {
-	return pj_sockaddr_get_str_addr(this);
-    }
-
+	return pj_inet_ntoa(sin_addr);
+    }
+
+    //
+    // Set IP address.
+    //
     void set_ip_address(pj_uint32_t addr)
     {
 	sin_family = PJ_AF_INET;
-	pj_sockaddr_set_addr(this, addr);
-    }
-
+	pj_sockaddr_in_set_addr(this, addr);
+    }
+
+    //
+    // Set address.
+    //
     pj_status_t set_address(const pj_str_t *addr)
     {
-	return pj_sockaddr_set_str_addr(this, addr);
-    }
-
+	return pj_sockaddr_in_set_str_addr(this, addr);
+    }
+
+    //
+    // Set address.
+    //
     pj_status_t set_address(const char *addr)
     {
-	return pj_sockaddr_set_str_addr2(this, addr);
-    }
-
-    int cmp(const PJ_INET_Addr &rhs) const
-    {
-	return pj_sockaddr_cmp(this, &rhs);
-    }
-
-    bool operator==(const PJ_INET_Addr &rhs) const
-    {
-	return cmp(rhs) == 0;
-    }
+        pj_str_t s;
+	return pj_sockaddr_in_set_str_addr(this, pj_cstr(&s, addr));
+    }
+
+    //
+    // Compare for equality.
+    //
+    bool operator==(const Pj_Inet_Addr &rhs) const
+    {
+	return sin_family == rhs.sin_family &&
+               sin_addr.s_addr == rhs.sin_addr.s_addr &&
+               sin_port == rhs.sin_port;
+    }
+
+private:
+    //
+    // Dummy length used in pj_ioqueue_recvfrom() etc
+    //
+    friend class Pj_Event_Handler;
+    friend class Pj_Socket;
+    friend class Pj_Sock_Stream;
+    friend class Pj_Sock_Dgram;
+
+    int addrlen_;
 };
 
-class PJ_Socket
+
+//
+// Socket base class.
+//
+// Note:
+//  socket will not automatically be closed on destructor.
+//
+class Pj_Socket
 {
 public:
-    PJ_Socket() {}
-    PJ_Socket(const PJ_Socket &rhs) : sock_(rhs.sock_) {}
-
+    //
+    // Default constructor.
+    //
+    Pj_Socket()
+        : sock_(PJ_INVALID_SOCKET) 
+    {
+    }
+
+    //
+    // Initialize from a socket handle.
+    //
+    explicit Pj_Socket(pj_sock_t sock)
+        : sock_(sock)
+    {
+    }
+
+    //
+    // Copy constructor.
+    //
+    Pj_Socket(const Pj_Socket &rhs) 
+        : sock_(rhs.sock_) 
+    {
+    }
+
+    //
+    // Destructor will not close the socket.
+    // You must call close() explicitly.
+    //
+    ~Pj_Socket()
+    {
+    }
+
+    //
+    // Set socket handle.
+    //
     void set_handle(pj_sock_t sock)
     {
@@ -73,4 +153,7 @@
     }
 
+    //
+    // Get socket handle.
+    //
     pj_sock_t get_handle() const
     {
@@ -78,4 +161,7 @@
     }
 
+    //
+    // Get socket handle.
+    //
     pj_sock_t& get_handle()
     {
@@ -83,91 +169,183 @@
     }
 
-    bool socket(int af, int type, int proto, pj_uint32_t flag=0)
-    {
-	sock_ = pj_sock_socket(af, type, proto, flag);
-	return sock_ != -1;
-    }
-
-    bool bind(const PJ_INET_Addr &addr)
-    {
-	return pj_sock_bind(sock_, &addr, sizeof(PJ_INET_Addr)) == 0;
-    }
-
-    bool close()
-    {
-	return pj_sock_close(sock_) == 0;
-    }
-
-    bool getpeername(PJ_INET_Addr *addr)
-    {
-	int namelen;
-	return pj_sock_getpeername(sock_, addr, &namelen) == 0;
-    }
-
-    bool getsockname(PJ_INET_Addr *addr)
-    {
-	int namelen;
-	return pj_sock_getsockname(sock_, addr, &namelen) == 0;
-    }
-
-    bool getsockopt(int level, int optname, void *optval, int *optlen)
-    {
-	return pj_sock_getsockopt(sock_, level, optname, optval, optlen) == 0;
-    }
-
-    bool setsockopt(int level, int optname, const void *optval, int optlen)
-    {
-	return pj_sock_setsockopt(sock_, level, optname, optval, optlen) == 0;
-    }
-
-    bool ioctl(long cmd, pj_uint32_t *val)
-    {
-	return pj_sock_ioctl(sock_, cmd, val) == 0;
-    }
-
-    int recv(void *buf, int len, int flag = 0)
-    {
-	return pj_sock_recv(sock_, buf, len, flag);
-    }
-
-    int send(const void *buf, int len, int flag = 0)
-    {
-	return pj_sock_send(sock_, buf, len, flag);
+    //
+    // See if the socket is valid.
+    //
+    bool is_valid() const
+    {
+        return sock_ != PJ_INVALID_SOCKET;
+    }
+
+    //
+    // Create the socket.
+    //
+    pj_status_t create(int af, int type, int proto)
+    {
+	return pj_sock_socket(af, type, proto, &sock_);
+    }
+
+    //
+    // Bind socket.
+    //
+    pj_status_t bind(const Pj_Inet_Addr &addr)
+    {
+	return pj_sock_bind(sock_, &addr, sizeof(Pj_Inet_Addr));
+    }
+
+    //
+    // Close socket.
+    //
+    pj_status_t close()
+    {
+	pj_sock_close(sock_);
+    }
+
+    //
+    // Get peer socket name.
+    //
+    pj_status_t getpeername(Pj_Inet_Addr *addr)
+    {
+	return pj_sock_getpeername(sock_, addr, &addr->addrlen_);
+    }
+
+    //
+    // getsockname
+    //
+    pj_status_t getsockname(Pj_Inet_Addr *addr)
+    {
+	return pj_sock_getsockname(sock_, addr, &addr->addrlen_);
+    }
+
+    //
+    // getsockopt.
+    //
+    pj_status_t getsockopt(int level, int optname, 
+                           void *optval, int *optlen)
+    {
+	return pj_sock_getsockopt(sock_, level, optname, optval, optlen);
+    }
+
+    //
+    // setsockopt
+    // 
+    pj_status_t setsockopt(int level, int optname, 
+                           const void *optval, int optlen)
+    {
+	return pj_sock_setsockopt(sock_, level, optname, optval, optlen);
+    }
+
+    //
+    // receive data.
+    //
+    pj_ssize_t recv(void *buf, pj_size_t len, int flag = 0)
+    {
+        pj_ssize_t bytes = len;
+	if (pj_sock_recv(sock_, buf, &bytes, flag) != PJ_SUCCESS)
+            return -1;
+        return bytes;
+    }
+
+    //
+    // send data.
+    //
+    pj_ssize_t send(const void *buf, pj_ssize_t len, int flag = 0)
+    {
+        pj_ssize_t bytes = len;
+	if (pj_sock_send(sock_, buf, &bytes, flag) != PJ_SUCCESS)
+            return -1;
+        return bytes;
+    }
+
+    //
+    // connect.
+    //
+    pj_status_t connect(const Pj_Inet_Addr &addr)
+    {
+	return pj_sock_connect(sock_, &addr, sizeof(Pj_Inet_Addr));
+    }
+
+    //
+    // assignment.
+    //
+    Pj_Socket &operator=(const Pj_Socket &rhs)
+    {
+        sock_ = rhs.sock_;
+        return *this;
     }
 
 protected:
+    friend class Pj_Event_Handler;
     pj_sock_t sock_;
 };
 
+
 #if PJ_HAS_TCP
-class PJ_Sock_Stream : public PJ_Socket
+//
+// Stream socket.
+//
+class Pj_Sock_Stream : public Pj_Socket
 {
 public:
-    PJ_Sock_Stream() {}
-    PJ_Sock_Stream(const PJ_Sock_Stream &rhs) : PJ_Socket(rhs) {}
-    PJ_Sock_Stream &operator=(const PJ_Sock_Stream &rhs) { sock_ = rhs.sock_; return *this; }
-
-    bool listen(int backlog = 5)
-    {
-	return pj_sock_listen(sock_, backlog) == 0;
-    }
-
-    bool accept(PJ_Sock_Stream *new_sock, PJ_INET_Addr *addr, int *addrlen)
-    {
-	pj_sock_t s = pj_sock_accept(sock_, addr, addrlen);
-	if (s == -1)
-	    return false;
-	new_sock->set_handle(s);
-	return true;
-    }
-
-    bool connect(const PJ_INET_Addr &addr)
-    {
-	return pj_sock_connect(sock_, &addr, sizeof(PJ_INET_Addr)) == 0;
-    }
-
-    bool shutdown(int how)
-    {
-	return pj_sock_shutdown(sock_, how) == 0;
+    //
+    // Default constructor.
+    //
+    Pj_Sock_Stream() 
+    {
+    }
+
+    //
+    // Initialize from a socket handle.
+    //
+    explicit Pj_Sock_Stream(pj_sock_t sock)
+        : Pj_Socket(sock)
+    {
+    }
+
+    //
+    // Copy constructor.
+    //
+    Pj_Sock_Stream(const Pj_Sock_Stream &rhs) : Pj_Socket(rhs) 
+    {
+    }
+
+    //
+    // Assignment.
+    //
+    Pj_Sock_Stream &operator=(const Pj_Sock_Stream &rhs) 
+    { 
+        sock_ = rhs.sock_; 
+        return *this; 
+    }
+
+    //
+    // listen()
+    //
+    pj_status_t listen(int backlog = 5)
+    {
+	return pj_sock_listen(sock_, backlog);
+    }
+
+    //
+    // blocking accept()
+    //
+    Pj_Sock_Stream accept(Pj_Inet_Addr *remote_addr = NULL)
+    {
+        pj_sock_t newsock;
+        int *addrlen = remote_addr ? &remote_addr->addrlen_ : NULL;
+        pj_status_t status;
+        
+        status = pj_sock_accept(sock_, &newsock, remote_addr, addrlen);
+        if (status != PJ_SUCCESS)
+            return Pj_Sock_Stream(-1);
+
+        return Pj_Sock_Stream(newsock);
+    }
+
+    //
+    // shutdown()
+    //
+    pj_status_t shutdown(int how = PJ_SHUT_RDWR)
+    {
+	return pj_sock_shutdown(sock_, how);
     }
 
@@ -175,22 +353,74 @@
 #endif
 
-class PJ_Sock_Dgram : public PJ_Socket
+//
+// Datagram socket.
+//
+class Pj_Sock_Dgram : public Pj_Socket
 {
 public:
-    PJ_Sock_Dgram() {}
-    PJ_Sock_Dgram(const PJ_Sock_Dgram &rhs) : PJ_Socket(rhs) {}
-    PJ_Sock_Dgram &operator=(const PJ_Sock_Dgram &rhs) { sock_ = rhs.sock_; return *this; }
-
-    int recvfrom(void *buf, int len, int flag, PJ_INET_Addr *fromaddr)
-    {
-	int addrlen;
-	return pj_sock_recvfrom(sock_, buf, len, flag, fromaddr, &addrlen);
-    }
-
-    int sendto(const void *buf, int len, int flag, const PJ_INET_Addr &addr)
-    {
-	return pj_sock_sendto(sock_, buf, len, flag, &addr, sizeof(PJ_INET_Addr));
+    //
+    // Default constructor.
+    //
+    Pj_Sock_Dgram() 
+    {
+    }
+
+    //
+    // Initialize from a socket handle.
+    //
+    explicit Pj_Sock_Dgram(pj_sock_t sock)
+        : Pj_Socket(sock)
+    {
+    }
+
+    //
+    // Copy constructor.
+    //
+    Pj_Sock_Dgram(const Pj_Sock_Dgram &rhs) 
+        : Pj_Socket(rhs) 
+    {
+    }
+
+    //
+    // Assignment.
+    //
+    Pj_Sock_Dgram &operator=(const Pj_Sock_Dgram &rhs) 
+    { 
+        Pj_Socket::operator =(rhs);
+        return *this; 
+    }
+
+    //
+    // recvfrom()
+    //
+    pj_ssize_t recvfrom( void *buf, pj_size_t len, int flag = 0, 
+                         Pj_Inet_Addr *fromaddr = NULL)
+    {
+        pj_ssize_t bytes = len;
+        int *addrlen = fromaddr ? &fromaddr->addrlen_ : NULL;
+	if (pj_sock_recvfrom( sock_, buf, &bytes, flag, 
+                              fromaddr, addrlen) != PJ_SUCCESS)
+        {
+            return -1;
+        }
+        return bytes;
+    }
+
+    //
+    // sendto()
+    //
+    pj_ssize_t sendto( const void *buf, pj_size_t len, int flag, 
+                       const Pj_Inet_Addr &addr)
+    {
+        pj_ssize_t bytes = len;
+	if (pj_sock_sendto( sock_, buf, &bytes, flag, 
+                            &addr, sizeof(pj_sockaddr_in)) != PJ_SUCCESS)
+        {
+            return -1;
+        }
+        return bytes;
     }
 };
 
+
 #endif	/* __PJPP_SOCK_H__ */
